Index: files.html
===================================================================
--- files.html	(revision 861)
+++ files.html	(revision 862)
@@ -4,23 +4,26 @@
 <link href="doxygen.css" rel="stylesheet" type="text/css">
 <link href="tabs.css" rel="stylesheet" type="text/css">
 </head><body>
-<!-- Generated by Doxygen 1.5.3 -->
-<div class="tabs">
-  <ul>
-    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
-    <li><a href="modules.html"><span>Modules</span></a></li>
-    <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
-    <li class="current"><a href="files.html"><span>Files</span></a></li>
-    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
-  </ul>
+<!-- Generated by Doxygen 1.5.5 -->
+<div class="navigation" id="top">
+  <div class="tabs">
+    <ul>
+      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
+      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
+      <li><a href="modules.html"><span>Modules</span></a></li>
+      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
+      <li class="current"><a href="files.html"><span>Files</span></a></li>
+    </ul>
+  </div>
+  <div class="tabs">
+    <ul>
+      <li class="current"><a href="files.html"><span>File&nbsp;List</span></a></li>
+      <li><a href="globals.html"><span>Globals</span></a></li>
+    </ul>
+  </div>
 </div>
-<div class="tabs">
-  <ul>
-    <li class="current"><a href="files.html"><span>File&nbsp;List</span></a></li>
-    <li><a href="globals.html"><span>Globals</span></a></li>
-  </ul>
-</div>
-<h1>libdragonfly File List</h1>Here is a list of all documented files with brief descriptions:<table>
+<div class="contents">
+<h1>File List</h1>Here is a list of all documented files with brief descriptions:<table>
   <tr><td class="indexkey"><a class="el" href="analog_8c.html">analog.c</a></td><td class="indexvalue">Analog input and output </td></tr>
   <tr><td class="indexkey"><a class="el" href="analog_8h.html">analog.h</a> <a href="analog_8h-source.html">[code]</a></td><td class="indexvalue">Contains functions and definitions for using the ADC </td></tr>
   <tr><td class="indexkey"><a class="el" href="battery_8c.html">battery.c</a></td><td class="indexvalue">Implementation for reading battery level </td></tr>
@@ -32,6 +35,7 @@
   <tr><td class="indexkey"><a class="el" href="dio_8h.html">dio.h</a> <a href="dio_8h-source.html">[code]</a></td><td class="indexvalue">Definitions for digital input / output </td></tr>
   <tr><td class="indexkey"><a class="el" href="dragonfly__lib_8c.html">dragonfly_lib.c</a></td><td class="indexvalue">Dragonfly initialization </td></tr>
   <tr><td class="indexkey"><a class="el" href="dragonfly__lib_8h.html">dragonfly_lib.h</a> <a href="dragonfly__lib_8h-source.html">[code]</a></td><td class="indexvalue">Contains other include files </td></tr>
+  <tr><td class="indexkey"><a class="el" href="eeprom_8h.html">eeprom.h</a> <a href="eeprom_8h-source.html">[code]</a></td><td class="indexvalue">Handles eeprom storage for persistent data </td></tr>
   <tr><td class="indexkey"><a class="el" href="i2c_8c.html">i2c.c</a></td><td class="indexvalue">Implemenation of I2C communications protocol </td></tr>
   <tr><td class="indexkey"><a class="el" href="i2c_8h.html">i2c.h</a> <a href="i2c_8h-source.html">[code]</a></td><td class="indexvalue">Header file for I2C </td></tr>
   <tr><td class="indexkey"><a class="el" href="lcd_8c.html">lcd.c</a></td><td class="indexvalue">LCD </td></tr>
@@ -52,8 +56,9 @@
   <tr><td class="indexkey"><a class="el" href="time_8c.html">time.c</a></td><td class="indexvalue">Timer code </td></tr>
   <tr><td class="indexkey"><a class="el" href="time_8h.html">time.h</a> <a href="time_8h-source.html">[code]</a></td><td class="indexvalue">Contains time-related functions and definitions </td></tr>
 </table>
-<hr size="1"><address style="text-align: right;"><small>Generated on Wed Feb 6 20:27:39 2008 for libdragonfly by&nbsp;
+</div>
+<hr size="1"><address style="text-align: right;"><small>Generated on Fri Sep 26 13:39:28 2008 for libdragonfly by&nbsp;
 <a href="http://www.doxygen.org/index.html">
-<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.3 </small></address>
+<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.5 </small></address>
 </body>
 </html>