Index: globals_0x79.html
===================================================================
--- globals_0x79.html	(revision 868)
+++ globals_0x79.html	(revision 869)
@@ -4,62 +4,59 @@
 <link href="doxygen.css" rel="stylesheet" type="text/css">
 <link href="tabs.css" rel="stylesheet" type="text/css">
 </head><body>
-<!-- Generated by Doxygen 1.5.5 -->
-<div class="navigation" id="top">
-  <div class="tabs">
-    <ul>
-      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
-      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
-      <li><a href="modules.html"><span>Modules</span></a></li>
-      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
-      <li class="current"><a href="files.html"><span>Files</span></a></li>
-    </ul>
-  </div>
-  <div class="tabs">
-    <ul>
-      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
-      <li class="current"><a href="globals.html"><span>Globals</span></a></li>
-    </ul>
-  </div>
-  <div class="tabs">
-    <ul>
-      <li class="current"><a href="globals.html"><span>All</span></a></li>
-      <li><a href="globals_func.html"><span>Functions</span></a></li>
-      <li><a href="globals_type.html"><span>Typedefs</span></a></li>
-      <li><a href="globals_defs.html"><span>Defines</span></a></li>
-    </ul>
-  </div>
-  <div class="tabs">
-    <ul>
-      <li><a href="globals.html#index__"><span>_</span></a></li>
-      <li><a href="globals_0x61.html#index_a"><span>a</span></a></li>
-      <li><a href="globals_0x62.html#index_b"><span>b</span></a></li>
-      <li><a href="globals_0x63.html#index_c"><span>c</span></a></li>
-      <li><a href="globals_0x64.html#index_d"><span>d</span></a></li>
-      <li><a href="globals_0x65.html#index_e"><span>e</span></a></li>
-      <li><a href="globals_0x66.html#index_f"><span>f</span></a></li>
-      <li><a href="globals_0x67.html#index_g"><span>g</span></a></li>
-      <li><a href="globals_0x68.html#index_h"><span>h</span></a></li>
-      <li><a href="globals_0x69.html#index_i"><span>i</span></a></li>
-      <li><a href="globals_0x6c.html#index_l"><span>l</span></a></li>
-      <li><a href="globals_0x6d.html#index_m"><span>m</span></a></li>
-      <li><a href="globals_0x6e.html#index_n"><span>n</span></a></li>
-      <li><a href="globals_0x6f.html#index_o"><span>o</span></a></li>
-      <li><a href="globals_0x70.html#index_p"><span>p</span></a></li>
-      <li><a href="globals_0x71.html#index_q"><span>q</span></a></li>
-      <li><a href="globals_0x72.html#index_r"><span>r</span></a></li>
-      <li><a href="globals_0x73.html#index_s"><span>s</span></a></li>
-      <li><a href="globals_0x74.html#index_t"><span>t</span></a></li>
-      <li><a href="globals_0x75.html#index_u"><span>u</span></a></li>
-      <li><a href="globals_0x77.html#index_w"><span>w</span></a></li>
-      <li><a href="globals_0x78.html#index_x"><span>x</span></a></li>
-      <li class="current"><a href="globals_0x79.html#index_y"><span>y</span></a></li>
-    </ul>
-  </div>
+<!-- Generated by Doxygen 1.5.4 -->
+<div class="tabs">
+  <ul>
+    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
+    <li><a href="modules.html"><span>Modules</span></a></li>
+    <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
+    <li class="current"><a href="files.html"><span>Files</span></a></li>
+    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
+  </ul>
+</div>
+<div class="tabs">
+  <ul>
+    <li><a href="files.html"><span>File&nbsp;List</span></a></li>
+    <li class="current"><a href="globals.html"><span>Globals</span></a></li>
+  </ul>
+</div>
+<div class="tabs">
+  <ul>
+    <li class="current"><a href="globals.html"><span>All</span></a></li>
+    <li><a href="globals_func.html"><span>Functions</span></a></li>
+    <li><a href="globals_type.html"><span>Typedefs</span></a></li>
+    <li><a href="globals_defs.html"><span>Defines</span></a></li>
+  </ul>
+</div>
+<div class="tabs">
+  <ul>
+    <li><a href="globals.html#index__"><span>_</span></a></li>
+    <li><a href="globals_0x61.html#index_a"><span>a</span></a></li>
+    <li><a href="globals_0x62.html#index_b"><span>b</span></a></li>
+    <li><a href="globals_0x63.html#index_c"><span>c</span></a></li>
+    <li><a href="globals_0x64.html#index_d"><span>d</span></a></li>
+    <li><a href="globals_0x65.html#index_e"><span>e</span></a></li>
+    <li><a href="globals_0x66.html#index_f"><span>f</span></a></li>
+    <li><a href="globals_0x67.html#index_g"><span>g</span></a></li>
+    <li><a href="globals_0x68.html#index_h"><span>h</span></a></li>
+    <li><a href="globals_0x69.html#index_i"><span>i</span></a></li>
+    <li><a href="globals_0x6c.html#index_l"><span>l</span></a></li>
+    <li><a href="globals_0x6d.html#index_m"><span>m</span></a></li>
+    <li><a href="globals_0x6e.html#index_n"><span>n</span></a></li>
+    <li><a href="globals_0x6f.html#index_o"><span>o</span></a></li>
+    <li><a href="globals_0x70.html#index_p"><span>p</span></a></li>
+    <li><a href="globals_0x71.html#index_q"><span>q</span></a></li>
+    <li><a href="globals_0x72.html#index_r"><span>r</span></a></li>
+    <li><a href="globals_0x73.html#index_s"><span>s</span></a></li>
+    <li><a href="globals_0x74.html#index_t"><span>t</span></a></li>
+    <li><a href="globals_0x75.html#index_u"><span>u</span></a></li>
+    <li><a href="globals_0x77.html#index_w"><span>w</span></a></li>
+    <li><a href="globals_0x78.html#index_x"><span>x</span></a></li>
+    <li class="current"><a href="globals_0x79.html#index_y"><span>y</span></a></li>
+  </ul>
+</div>
 
 <p>
-</div>
-<div class="contents">
 Here is a list of all documented functions, variables, defines, enums, and typedefs with links to the documentation:
 <p>
 <h3><a class="anchor" name="index_y">- y -</a></h3><ul>
@@ -66,9 +63,8 @@
 <li>YELLOW
 : <a class="el" href="group__orbs.html#gbf681265909adf3d3e8116c93c0ba179">lights.h</a>
 </ul>
-</div>
-<hr size="1"><address style="text-align: right;"><small>Generated on Fri Sep 26 13:39:28 2008 for libdragonfly by&nbsp;
+<hr size="1"><address style="text-align: right;"><small>Generated on Mon Oct 6 15:44:34 2008 for libdragonfly by&nbsp;
 <a href="http://www.doxygen.org/index.html">
-<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.5 </small></address>
+<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.4 </small></address>
 </body>
 </html>