commit 887b4a1abdaf5a378dca497732905512595e3dff
Author: Tom Mullins <tmullins@andrew.cmu.edu>
Date:   Wed Nov 7 12:36:58 2012 -0500

    Removed bom.cpp, bom.h, get_bom_reading.srv, and query_sonar.srv
    
    Removed them for real this time; not pretend :D

diff --git a/scout/bom/src/bom.cpp b/scout/bom/src/bom.cpp
deleted file mode 100644
index 57a0697..0000000
--- a/scout/bom/src/bom.cpp
+++ /dev/null
@@ -1,108 +0,0 @@
-/**
- * Copyright (c) 2011 Colony Project
- * 
- * Permission is hereby granted, free of charge, to any person
- * obtaining a copy of this software and associated documentation
- * files (the "Software"), to deal in the Software without
- * restriction, including without limitation the rights to use,
- * copy, modify, merge, publish, distribute, sublicense, and/or sell
- * copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following
- * conditions:
- * 
- * The above copyright notice and this permission notice shall be
- * included in all copies or substantial portions of the Software.
- * 
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
- * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
- * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
- * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
- * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
- * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
- * OTHER DEALINGS IN THE SOFTWARE.
- */
-
-/**
- * @file bom.cpp
- * @brief Contains code to control the bom.
- *
- * Implementation of functions for bom use.
- *
- * @author Colony Project, CMU Robotics Club
- * @author キャロル　ジェムス
- **/
-
-#include "ros/ros.h"
-#include "bom.h"
-//#include "libscout/src/constants.h"
-#include <cstdlib>
-
-/**
- * @defgroup bom Bom
- * @brief Functions for using the bom
- *
- * @{
- **/
-
-
-/**A psuedo function to make the below code compile**/
-int get_response_from_avr(bom::get_bom_reading::Request &req,
-                          bom::get_bom_reading::Response &res)
-{
-  /**
-   * The actual function will be in the avr, and will get the data
-   * directly off of the boms
-  **/
-  return 1;
-}
-
-
-/**
- * @brief Sends who you want to look for, and returns the specific data
- *
- * Serves the service get_bom_reading by responding to service requests with the
- * values of the boms.
- * @param req The request. Should contain the name of the target bot and this
- *     bots name..
- * @param res The response. The fields will be filled with values.
- */
-bool get_data(bom::get_bom_reading::Request &req,
-             bom::get_bom_reading::Response &res)
-{
-    /**TODO is that how you pass the values across? need the ampersands?**/
-    get_response_from_avr(req,res);
-    /**TODO if you haven't noticed, reader, this shouldn't work ...ask Priya **/
-    ROS_DEBUG("Data Recieved! Not");
-    return true;
-}
-
-/**
- * @brief Bom driver. This is a ROS node that controls bom communication.
- *
- * This is the main function for the bom node. It is run when the node
- * starts and initializes the bom. It then advertises the
- * get_bom_reading service.
- * 
- * @param argc The number of command line arguments (should be 1)
- * @param argv The array of command line arguments
- **/
-int main(int argc, char **argv)
-{
-    /* Initialize in ROS the bom driver node */
-    ros::init(argc, argv, "bom_driver");
-
-    /* Advertise that this serves the get_bom_reading service */
-    ros::NodeHandle n;
-    ros::ServiceServer service = n.advertiseService("get_bom_reading",
-                                                    get_data);
-
-    // Hardware init functions here
-
-    ROS_INFO("Ready to communicate with the bom.");
-    ros::spin();
-
-    return 0;
-}
-
-/** @} **/
diff --git a/scout/bom/src/bom.h b/scout/bom/src/bom.h
deleted file mode 100644
index 06f020e..0000000
--- a/scout/bom/src/bom.h
+++ /dev/null
@@ -1,49 +0,0 @@
-/**
- * Copyright (c) 2011 Colony Project
- * 
- * Permission is hereby granted, free of charge, to any person
- * obtaining a copy of this software and associated documentation
- * files (the "Software"), to deal in the Software without
- * restriction, including without limitation the rights to use,
- * copy, modify, merge, publish, distribute, sublicense, and/or sell
- * copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following
- * conditions:
- * 
- * The above copyright notice and this permission notice shall be
- * included in all copies or substantial portions of the Software.
- * 
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
- * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
- * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
- * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
- * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
- * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
- * OTHER DEALINGS IN THE SOFTWARE.
- */
-
-/**
- * @file bom.h
- * @brief Contains bom declarations and functions.
- * 
- * Contains functions and definitions for the use of
- * bom.
- *
- * @author Colony Project, CMU Robotics Club
- * @author ジェームス　キャロル
- **/
-
-#ifndef _BOM_H_
-#define _BOM_H_
-
-#include "bom/get_bom_reading.h"
-
-/** @brief Initialize the bom module and driver. **/
-int main(int argc, char **argv);
-
-/** @brief Responds to service to get specific bom data**/
-bool get_data(bom::get_bom_reading::Request &req,
-             bom::get_bom_reading::Response &res);
-
-#endif
diff --git a/scout/bom/srv/get_bom_reading.srv b/scout/bom/srv/get_bom_reading.srv
deleted file mode 100644
index 01a1a34..0000000
--- a/scout/bom/srv/get_bom_reading.srv
+++ /dev/null
@@ -1,29 +0,0 @@
-#TODO not sure what magnitude the boms span, ie change the 8 to something right
-#TODO from sounds weird, think of something better
-
-#NOTE; if say a -1 was used for the bom_targ_name, then maybe it would just 
-#   >  send back the raw data or something.
-
-#The number assicoiated with the robot you want to listen for
-int8 bom_targ_name
-#Your robot number, just in case you want to pretend to be someone else
-int8 bom_my_name
-
----
-#The data recieved
-#Of the form: magnitude recieved, from which robot, from which bom on that bot
-int8 bom0_mag
-int8 bom0_from
-int8 bom0_from_bom
-
-int8 bom1_mag
-int8 bom1_from
-int8 bom1_from_bom
-
-int8 bom2_mag
-int8 bom2_from
-int8 bom2_from_bom
-
-int8 bom3_mag
-int8 bom3_from
-int8 bom3_from_bom
diff --git a/scout/messages/srv/query_sonar.srv b/scout/messages/srv/query_sonar.srv
deleted file mode 100644
index 90f3dc5..0000000
--- a/scout/messages/srv/query_sonar.srv
+++ /dev/null
@@ -1,6 +0,0 @@
-int8 direction
----
-#front sonar
-int16 distance0
-#back sonar
-int16 distance1